-- by mor2000

PlaceableSilo={}
PlaceableSilo_mt = Class(PlaceableSilo, PlaceableUPK)
InitObjectClass(PlaceableSilo, "PlaceableSilo")

function PlaceableSilo:new(isServer, isClient, customMt)
	local self = PlaceableUPK:new(isServer, isClient, customMt or PlaceableSilo_mt)
	registerObjectClassName(self, "PlaceableSilo")
	self.isServer=isServer
	self.isClient=isClient
	return self
end

function PlaceableSilo:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not PlaceableSilo:superClass().loadFromAttributesAndNodes(self, xmlFile, key, resetVehicles) then
		return false
	end
	local foundOldSilos=false
	for i=1,4 do
		local siloKey = key .. string.format(".silo%d", i)
		if hasXMLProperty(xmlFile, siloKey) then
			local foundOldSilos=true
			local fillTypeString = Utils.getNoNil(getXMLString(xmlFile, siloKey .. "#fillType"),"unknown")
			local fillLevel = Utils.getNoNil(getXMLFloat(xmlFile, siloKey .. "#fillLevel"),0)
		
			local fillType=Fillable.fillTypeNameToInt[fillTypeString]
			if(fillType~=nil and fillType~=Fillable.FILLTYPE_UNKNOWN)then
				local filltypechanger=self.base.kids[1]
				if type(filltypechanger)=="table" then
					filltypechanger.tiptriggerFillTypes[fillType]=true
					filltypechanger.fillTypesToSilos[fillType]=filltypechanger.storageKids[i]
					filltypechanger.storageKids[i]:setFillLevel(fillLevel,fillType)
				end
			end
		end
	end
	
	if foundOldSilos and type(self.base.kids[1])=="table" then
		self.base.kids[1]:setAcceptedFillTypes()
	end
	return true
end

function PlaceableSilo:delete()
	unregisterObjectClassName(self)
	PlaceableSilo:superClass().delete(self)
end


